<?php

define( "ICON_NOTE", 0 );
define( "ICON_ALERT", 1 );
define( "ICON_ERROR", 2 );

function cpanel_Login( $status ) {
	global $path_to_pictures, $cpanel_header, $cpanel_footer;

	$message = "MLM &gt; Login";
	if ( $status ) { $message .= " Failed!"; }
	$output  = str_replace( "[PAGE_TITLE]", $message, $cpanel_header );
	
	$message = "<a href=\"lm.php\">MLM</a> <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> <a href=\"lm.php\">Login</a>";
	if ( $status ) { $message = "<a href=\"lm.php\">MLM</a> <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> <span style=\"color: #F00; font-weight: normal; text-decoration: blink;\">Login Failed!</span>"; }
	$output  = str_replace( "[PAGE_ROUTE]", $message, $output );
	
	$output .= "<form id=\"form1\" name=\"form1\" method=\"post\" action=\"lm.php\">
				<div align=\"center\">
				<table width=\"200\" border=\"0\">
				<tr>
				<td><p><span class=\"label\">User ID:</span><br />
				<label for=\"textfield\"></label>
				<input name=\"uid\" type=\"text\" class=\"textfield\" id=\"textfield\" />
				<span class=\"label\">Password:</span><br />
				<input name=\"pwd\" type=\"password\" class=\"textfield\" id=\"textfield6\" />
				</p>
				<div align=\"right\">
				<input type=\"reset\" name=\"button2\" id=\"button3\" class=\"formbutton\" value=\"Reset\" />&nbsp;
				<input type=\"submit\" name=\"button2\" id=\"button4\" class=\"formbutton\" value=\"Login\" />
				</div>
				<p>
				<input type=\"hidden\" name=\"cmd\" id=\"hiddenField\" value=\"admin\" />
				<input type=\"hidden\" name=\"action\" id=\"hiddenField\" value=\"login\" />
				</p></td>
				</tr>
				</table>
				</div> 
				</form>"; 
			  
	$output .= $cpanel_footer;
	echo $output;
}

function cpanel_Main() {
	global $path_to_pictures, $cpanel_header, $cpanel_footer;

	$output  = str_replace( "[PAGE_TITLE]", "MLM &gt; Main", $cpanel_header );
	$output  = str_replace( "[PAGE_ROUTE]", "<a href=\"lm.php\">MLM</a> <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> <a href=\"lm.php\">Main</a>", $output );
	
	$output .= "<div align=\"center\">
				<table width=\"200\" border=\"0\">
				<tr>
				<td><div align=\"center\">
				<br />
				<button class=\"largebutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlists'\"><b>Show Lists</b></button>
				<br />
				<button class=\"largebutton\" onClick=\"window.location='lm.php?cmd=admin&action=showdeliveries'\"><b>Statistics</b></button>
				<br />
				<hr />
				<button class=\"largebutton\" onClick=\"window.location='lm.php?cmd=admin&action=logout'\"><b>Log Out</b></button>
				<br />
				<br />
				</div></td>
				</tr>
				</table>
				</div>";
			  
	$output .= $cpanel_footer;
	echo $output;
}

function cpanel_ShowLists() {
	global $path_to_pictures, $cpanel_header, $cpanel_footer;
	global $pwd;

	$output  = str_replace( "[PAGE_TITLE]", "MLM &gt; Lists", $cpanel_header );
	$output  = str_replace( "[PAGE_ROUTE]", "<a href=\"lm.php\">MLM</a> <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a>", $output);
	
	$output .= "<div align=\"center\">
				<table width=\"CPANEL_WIDTH\" border=\"0\">
				<tr>
				<td><div align=\"center\">
				<table width=\"100%\" border=\"0\"  cellpadding=\"3\" cellspacing=\"0\">\n";
	
	$output .= "<tr><td></td></tr>\n";
	$output .= "<tr class=\"stdtext\">\n";
	$output .= "<td colspan=\"5\">\n";
	
	$output .= "<table border=\"0\"  cellpadding=\"0\" cellspacing=\"0\">\n";
	$output .= "<tr class=\"stdtext\">\n";
	$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=newlist\"><img src=\"$path_to_pictures/icon_add.png\" border=\"0\"></a></td>\n";
	$output .= "<td align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=newlist\">New</a>&nbsp;&nbsp;\n";
	
	if ( CPANEL_BROWSER <> "iPhone" ) {
		$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=upload\"><img src=\"$path_to_pictures/icon_upload.png\" border=\"0\"></a></td>\n";
		$output .= "<td align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=upload\">Upload</a>&nbsp;&nbsp;\n";
	}
	
	$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=find\"><img src=\"$path_to_pictures/icon_search.png\" border=\"0\"></a></td>\n";
	$output .= "<td align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=findaddr\">Find</a>\n";
	
	$output .= "</td>\n";
	$output .= "</tr>\n";
	$output .= "</table>\n";
	
	$output .= "</td>\n";
	$output .= "</tr>\n";
	$output .= "<tr><td></td></tr>\n";
	
		
	$lists = explode( "\n", ShowLists() );
	$mycount = 0;
	usort( $lists, "SortByName" );
	foreach ( $lists as $list ) {
		list( $name, $count, $date ) = explode( "\t", $list );
		if ( trim( $name <> "" ) ) {
		
			if ( $mycount % 2 == 0 ) { $style = "d0"; } else { $style = "d1"; }
			$mycount++;
			//$style = "d2";
		
			$output .= "<tr class=\"$style\">\n";
			$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=removelist&list=" . urlencode( $name ) . "&conf=no\"><img src=\"$path_to_pictures/icon_delete.png\" border=\"0\"></a></td>\n";
			$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=renamelist&list=" . urlencode( $name ) . "\"><img src=\"$path_to_pictures/icon_edit.png\" border=\"0\"></a></td>\n";
			if ( CPANEL_BROWSER <> "iPhone" ) {
				$output .= "<td class=\"stdtext\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $name ) . "&page=1&size=$count\">$name</a> <span class=\"stdtextmedium\">($count)</span></td>\n";
			} else {
				$output .= "<td class=\"stdtext\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $name ) . "&page=1&size=$count\">" . CropText( $name, 25 ) . "</a> <span class=\"stdtextmedium\">($count)</span></td>\n";
			}
			$output .= "<td width=\"14\"><a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $name ) . "&page=1&size=$count\"><img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"></a></td>\n";
			$output .= "</tr>\n";
		}
	}
		
	$output .= "</table>
				<hr />
				<button class=\"largebutton\" onClick=\"window.location='lm.php'\"><b>Main Menu</b></button>
				<br />
				<br />
				</div></td>
				</tr>
				</table>
				</div>";
			  
	$output .= $cpanel_footer;
	echo $output;
}

function cpanel_ShowList() {
	global $path_to_pictures, $cpanel_header, $cpanel_footer;
	global $list, $page, $size, $rowsperpage;
	
	$size = GetListSize( $list ); // Despite $size is received when coming from the list of lists we calcultate it since we can also come from the recipient editor	
	$title = "MLM &gt; Lists &gt; $list";
	$mycount = 0;
	
	if ( CPANEL_BROWSER <> "iPhone" ) {
		$route = "<a href=\"lm.php\">MLM</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "&page=1&size=$size\">$list</a> \n";
	} else {
		$route = "<a href=\"lm.php\">MLM</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "&page=1&size=$size\">" . CropText( $list, 10 ) . "</a> \n";
	}
	
	$output  = str_replace( "[PAGE_TITLE]", $title, $cpanel_header );
	$output  = str_replace( "[PAGE_ROUTE]", $route, $output );
	
	$output .= "<div align=\"center\">
			  <table width=\"CPANEL_WIDTH\" border=\"0\">
			  <tr>
			  <td><div align=\"center\">
			  <table width=\"100%\" border=\"0\"  cellpadding=\"3\" cellspacing=\"0\">\n";
			  
	$output .= "<tr><td></td></tr>\n";
	$output .= "<tr class=\"stdtext\">\n";
	$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=editaddr&list=" . urlencode( $list ) . "\"><img src=\"$path_to_pictures/icon_add.png\" border=\"0\"></a></td>\n";
	$output .= "<td colspan=\"5\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=editaddr&list=" . urlencode( $list ) . "\">Add Recipient</a></td>\n";
	$output .= "</tr>\n";
	$output .= "<tr><td></td></tr>\n";
	
	$start = ( $rowsperpage * ( $page - 1 ) ) + 1; // Compute $start and $rows
	$subscribers = explode( "\n", GetList( $list, $start, $rowsperpage ) );
	//usort( $subscribers, "SortByName" );
	foreach ( $subscribers as $subscriber ) {
		if ( $subscriber <> "" ) {
			list( $firstname, $lastname, $company, $email ) = explode( "\t", $subscriber );
				if ( trim( $email <> "" ) ) {
					$fullname = trim( trim( $firstname ) . " " . trim( $lastname ) );
					//$data = trim( trim( $firstname ) . " " . trim( $lastname ) );
					if ( trim( $company ) <> "" ) {
						if ( $fullname <> "" ) { $fullname .= ", "; }
						$fullname .= trim( $company );
					}
					if ( trim( $fullname ) == "" ) { $fullname = "..."; }
					$data = trim( $email );
				
					if ( $mycount % 2 == 0 ) { $style = "d0"; } else { $style = "d1"; }
					$mycount++;
					//$style = "d2";
								
					$output .= "<tr class=\"$style\">\n";
					$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=removeaddr&list=" . urlencode( $list ) . "&email=" . urlencode( $email ) . "&conf=no\"><img src=\"$path_to_pictures/icon_delete.png\" border=\"0\"></a></td>\n";
					$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=editaddr&list=" . urlencode( $list ) . "&firstname=" . urlencode( $firstname ) . "&lastname=" . urlencode( $lastname ) . "&company=" . urlencode( $company ) . "&email=" . urlencode( $email ) . "\"><img src=\"$path_to_pictures/icon_edit.png\" border=\"0\"></a></td>\n";
					if ( CPANEL_BROWSER == "iPhone" ) {
						$output .= "<td class=\"stdtext\" align=\"left\">&nbsp;<b>" . CropText( $fullname, 22 ) . "</b><br />&nbsp;<a href=\"lm.php?cmd=admin&action=sendemail&list=" . urlencode( $list ) . "&firstname=" . urlencode( $firstname ) . "&lastname=" . urlencode( $lastname ) . "&company=" . urlencode( $company ) . "&email=" . urlencode( $email ) . "\">" . CropText( $data, 22 ) . "</a></td>\n";
					} else {
						$output .= "<td class=\"stdtext\" align=\"left\">&nbsp;<b>" . CropText( $fullname, 40 ) . "</b></td>\n";
						$output .= "<td class=\"stdtext\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=sendemail&list=" . urlencode( $list ) . "&firstname=" . urlencode( $firstname ) . "&lastname=" . urlencode( $lastname ) . "&company=" . urlencode( $company ) . "&email=" . urlencode( $email ) . "\">" . CropText( $data, 40 ) . "</a></td>\n";
					}
					$output .= "<td width=\"14\"><a href=\"lm.php?cmd=admin&action=editaddr&list=" . urlencode( $list ) . "&firstname=" . urlencode( $firstname ) . "&lastname=" . urlencode( $lastname ) . "&company=" . urlencode( $company ) . "&email=" . urlencode( $email ) . "\"><img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"></a></td>\n";
					$output .= "</tr>\n";
				}
			}
		}
	$output .= "</table>\n";
	
	$pages = floor( $size / $rowsperpage );
	If ( $size % $rowsperpage <> 0 ) { $pages++; }
	if ( $pages <= 1 ) {
		$nav = "";
	} else {
		if ( CPANEL_BROWSER == "iPhone" ) { $max = 24; } else { $max = 40; }
		
		$tmp_s = "";
		$tmp_x = $page;
		while ( strlen( $tmp_s ) < $max ) {
			if ( $tmp_s != "" ) { $tmp_s .= " "; }
			$tmp_s .= "$tmp_x";
			$tmp_x++;
			$offset++;
		}

		$j = $page - Floor( $offset / 2 );
		if ( $j <= 0 ) { $j = 1; }
		
		while ( strlen( $txt ) < $max && $j <= $pages ) {
			if ( $nav != "" ) {
				$nav .= " ";
				$txt .= " ";
			}
			if ( $j == $page ) {
				$nav .= "$j";
			} else {
				$nav .= "<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "&page=$j&size=$size\">$j</a>";
			}
			$txt .= "$j";
			$j++;
		}
	}
	
	$prev = intval( $page ) - 1;
	$next = intval( $page ) + 1;
	
	if ( $prev > 0 || ( intval( $page ) * intval( $rowsperpage ) ) < intval( $size )  ) { 
	
		$output .= "<hr />
					<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">
					<tr>
					<td align=\"center\">					
					<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">
					<tr>";
											
		if ( $prev > 0 ) { 
			$output .= "<td align=\"center\"><a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "&page=1&size=$size\"><img src=\"$path_to_pictures/icon_first.png\" border=\"0\"></a></td>
						<td align=\"center\"><a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "&page=$prev&size=$size\"><img src=\"$path_to_pictures/icon_previous.png\" border=\"0\"></a></td>\n";
		} else {
			$output .= "<td align=\"center\"><img src=\"$path_to_pictures/icon_first_disabled.png\" border=\"0\"></td>
						<td align=\"center\"><img src=\"$path_to_pictures/icon_previous_disabled.png\" border=\"0\"></td>\n";
		}
		
		If ( $nav <> "" ) {
			$output .= "<td class=\"stdtext\" align=\"center\">&nbsp;$nav&nbsp;</td>\n";
		} else {
			$output .= "<td class=\"stdtext\" align=\"center\">&nbsp;</td>\n";
		}
		
		if ( ( intval( $page ) * intval( $rowsperpage ) < intval( $size ) ) ) { 
			$output .= "<td align=\"center\"><a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "&page=$next&size=$size\"><img src=\"$path_to_pictures/icon_next.png\" border=\"0\"></a></td>
						<td align=\"center\"><a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "&page=$pages&size=$size\"><img src=\"$path_to_pictures/icon_last.png\" border=\"0\"></a></td>\n";
		} else {
			$output .= "<td align=\"center\"><img src=\"$path_to_pictures/icon_next_disabled.png\" border=\"0\"></td>
						<td align=\"center\"><img src=\"$path_to_pictures/icon_last_disabled.png\" border=\"0\"></td>\n";
		}
		
		$output .= "</td></tr>
					</table>\n					
					</td></tr>
					</table>\n";
	}				

	$output .= "<hr />
				<button class=\"largebutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlists'\"><b>Return to Lists</b></button>
				<br />
				<button class=\"largebutton\" onClick=\"window.location='lm.php'\"><b>Main Menu</b></button>
				<br />
				<br />
				</div></td>
				</tr>
				</table>
				</div>";
			  
	$output .= $cpanel_footer;
	echo $output;
}

function cpanel_deletelist( $listname, $confirmed ) {
	global $path_to_pictures, $kErr_cmdprocessor_ulf, $kErr_cmdprocessor_rlu, $lang;
	global $use_mysql, $mysql_err, $mlm_err ;
	
	if ( $confirmed == 'no' ) {
	
		$title   = "MLM &gt; Lists &gt; Delete $listname";
		$route   = "<a href=\"lm.php\">MLM</a> 
				    <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    <a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "\">$listname</a>";
		$icon    = ICON_ALERT;
		$message = "Are you sure you want to delete the list '$listname'?";
	    $buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlists'\"><b>Cancel</b></button> 
				    <button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=removelist&list=" . urlencode( $listname ) . "&conf=yes'\"><b>Ok</b></button>";
	
		cpanel_showdialog( $title, $route, $icon, $message, $buttons );
				  
	} else {
		
		If ( list_exists( $listname ) ) {

			$result = RemoveList( $listname );
			
			if ( !$result ) { // Error - Impossible to remove the list(s).
			
				if ( $use_mysql == 1 ) { $errorstr = " [$mysql_err]"; } else { $errorstr = " " . print_r( $mlm_err, true ); }
				
				$title   = "MLM &gt; Lists &gt; Delete $listname";
				$route   = "<a href=\"lm.php\">MLM</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "\">$listname</a>";
				$icon    = ICON_ERROR;
				$message = $kErr_cmdprocessor_rlu[$lang] . $errorstr;
	    		$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlists'\"><b>Ok</b></button>";
	
				cpanel_showdialog( $title, $route, $icon, $message, $buttons );
	
			} else { // List removed successfully
				$url = "lm.php?cmd=admin&action=showlists";
				header( "Location: $url" );
			}

		} else { // Error - The list '$listname' was not found on this server.
		
			$title   = "MLM &gt; Lists &gt; Delete $listname";
			$route   = "<a href=\"lm.php\">MLM</a> 
				    	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    	<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    	<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "\">$listname</a>";
			$icon    = ICON_ERROR;
			$message = str_replace( "[LIST]", "'" . $listname . "'", $kErr_cmdprocessor_ulf[$lang] );
	    	$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlists'\"><b>Ok</b></button>";
	
			cpanel_showdialog( $title, $route, $icon, $message, $buttons );
			
		}
	
	}

}

function cpanel_deleterecipient( $listname, $email, $confirmed ) {
	global $path_to_pictures, $kErr_cmdprocessor_ulf, $kErr_cmdprocessor_rlu, $lang;
	global $kErr_cmdprocessor_unk, $kErr_cmdprocessor_usk;
	global $use_mysql, $mysql_err, $mlm_err;
	
	if ( $confirmed == 'no' ) {
	
		$title   = "MLM &gt; Lists &gt; Delete $email";
		$route   = "<a href=\"lm.php\">MLM</a> 
				    <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    <a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "\">$listname</a>";
		$icon    = ICON_ALERT;
		$message = "Are you sure you want to delete '$email' from '$listname'?";
	    $buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "'\"><b>Cancel</b></button> 
				    <button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=removeaddr&list=" . urlencode( $listname ) . "&email=" . urlencode( $email ) . "&conf=yes'\"><b>Ok</b></button>";
	
		cpanel_showdialog( $title, $route, $icon, $message, $buttons );
				  
	} else {
		
		If ( list_exists( $listname ) ) {
			
			$num = RemoveEmailFromList( $listname, $email );
			
			if ( $num == 0 ) { // Error - The email address [email] was not found in [list]

				$title   = "MLM &gt; Lists &gt; Delete $email";
				$route   = "<a href=\"lm.php\">MLM</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "\">$listname</a>";
				$icon    = ICON_ERROR;
				$message = str_replace( "[LIST]", "'" . $listname . "'", str_replace( "[EMAIL]", "'" . $email . "'", $kErr_cmdprocessor_unk[$lang] ) );
	    		$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "'\"><b>Ok</b></button>";
	
				cpanel_showdialog( $title, $route, $icon, $message, $buttons );
				
			} else if ( $num == -1 ) { // Error - Server problem when trying to unsubscribe [email] from [list].
				
				if ( $use_mysql == 1 ) { $errorstr = " [$mysql_err]"; } else { $errorstr = " " . print_r( $mlm_err, true ); }
				
				$title   = "MLM &gt; Lists &gt; Delete $email";
				$route   = "<a href=\"lm.php\">MLM</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "\">$listname</a>";
				$icon    = ICON_ERROR;
				$message = str_replace( "[LIST]", "'" . $list . "'", str_replace( "[EMAIL]", "'" . $email . "'", $kErr_cmdprocessor_usk[$lang] ) ) . $errorstr;
	    		$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "'\"><b>Ok</b></button>";
	
				cpanel_showdialog( $title, $route, $icon, $message, $buttons );
	
			} else { // Email address removed successfully
				$url = "lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname );
				header( "Location: $url" );
			}

		} else { // Error - The list '$listname' was not found on this server.
		
			$title   = "MLM &gt; Lists &gt; Delete $listname";
			$route   = "<a href=\"lm.php\">MLM</a> 
				    	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    	<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    	<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "\">$listname</a>";
			$icon    = ICON_ERROR;
			$message = str_replace( "[LIST]", "'" . $listname . "'", $kErr_cmdprocessor_ulf[$lang] );
	    	$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlists'\"><b>Ok</b></button>";
	
			cpanel_showdialog( $title, $route, $icon, $message, $buttons );
			
		}
	
	}

}

// Rename or create a list
function cpanel_editlist() {
	global $cmd, $list, $newname, $action, $result;
	global $path_to_pictures, $cpanel_header, $cpanel_footer;
	global $kErr_cmdprocessor_gsp, $kErr_cmdprocessor_ulf, $lang;
	global $use_mysql, $mysql_err, $mlm_err;
	
	$listname = $list;
	
	if ( $result == "ok" && trim( $newname ) == "" ) { 
		$result = "err";
		$listname = $newname;
	}
	
	if ( $result == "ok" && list_exists( $newname ) && ( $list <> $newname || $action == "newlist" ) ) { 
		$result = "dup";
		$listname = $newname;
	}
	
	if ( $result == "err" ) {
		$title = "MLM &gt; Invalid List Name!";
		$route = "<a href=\"lm.php\">MLM</a>
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\">
				  <span style=\"color: #F00; font-weight: normal; text-decoration: blink;\">Invalid List Name!</span>";
	} else if ( $result == "dup" ) {
		$title = "MLM &gt; List already exists!";
		$route = "<a href=\"lm.php\">MLM</a>
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\">
				  <span style=\"color: #F00; font-weight: normal; text-decoration: blink;\">List already exists!</span>";
	} else {
		if ( $action == "renamelist" ) {
			$title = "MLM &gt; Rename List";
			$route = "<a href=\"lm.php\">MLM</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <span style=\"color: #666; font-weight: normal;\">Rename List</span>";
		} else if ( $action == "newlist" ) {
			$title = "MLM &gt; New List";
			$route = "<a href=\"lm.php\">MLM</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <span style=\"color: #666; font-weight: normal;\">New List</span>";
		}		
	}
	
	$page  = str_replace( "[PAGE_TITLE]", $title, $cpanel_header );
	$page  = str_replace( "[PAGE_ROUTE]", $route, $page );
	
	if ( $result == "ok" ) {

		If ( list_exists( $list ) || $action == "newlist" ) {
			
			if ( $action == "renamelist" ) {
				$result = RenameList( $list, $newname );
			} else if ( $action == "newlist" ) {
				$cmd   = "subscribe";
				$reqref = GetUniqueReference();
				if ( SaveRequest( $reqref ) ) {
					if ( AddEmailToList( $reqref ) ) { $result = True; } else { $result = False; }
				} else {
					$result = False;
				}
			}
			
			if ( !$result ) { // Error - Server problem when reading list.

				if ( $use_mysql == 1 ) { $errorstr = " [$mysql_err]"; } else { $errorstr = " " . print_r( $mlm_err, true ); }
				
				$title   = "MLM &gt; Rename List";
				$route   = "<a href=\"lm.php\">MLM</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">$list</a>";
				$icon    = ICON_ERROR;
				$message = $kErr_cmdprocessor_gsp[$lang] . $errorstr;
	    		$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "'\"><b>Ok</b></button>";
	
				cpanel_showdialog( $title, $route, $icon, $message, $buttons );
	
			} else { // Recipient saved successfully!
				$url = "lm.php?cmd=admin&action=showlists";
				header( "Location: $url" );
			}
			
		} else { // Error - The list '$list' was not found on this server.
				
			$title   = "MLM &gt; Edit Address";
			$route   = "<a href=\"lm.php\">MLM</a> 
				    	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    	<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    	<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">$list</a>";
			$icon    = ICON_ERROR;
			$message = str_replace( "[LIST]", "'" . $list . "'", $kErr_cmdprocessor_ulf[$lang] );
	    	$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "'\"><b>Ok</b></button>";
	
			cpanel_showdialog( $title, $route, $icon, $message, $buttons );
			
		}

	} else if ( $result == "" || $result == "err" || $result == "dup" ) { // Show the list rename screen with data populated
	
		$page .= "<form id=\"form1\" name=\"form1\" method=\"post\" action=\"lm.php\">
			  	  <div align=\"center\">
			  	  <table width=\"200\" border=\"0\">
			  	  <tr>
			  	  <td>";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= "<p>"; }
		$page .= "<span class=\"label\">List Name:</span><br />
			  	  <input name=\"newname\" type=\"text\" class=\"textfieldedit\" id=\"textfield1\" value=\"$listname\" />";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= "</p>"; } else { $page .= "<p>"; }
		$page .= "<div align=\"right\">
			  	  <input type=\"submit\" name=\"result\" id=\"button1\" class=\"formbutton\" value=\"Cancel\" />&nbsp;
			  	  <input type=\"submit\" name=\"result\" id=\"button2\" class=\"formbutton\" value=\"Ok\" />
			  	  </div>";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= ""; } else { $page .= "</p>"; }	  	  
		$page .= "<input type=\"hidden\" name=\"cmd\" id=\"hiddenField\" value=\"admin\" />
			  	  <input type=\"hidden\" name=\"action\" id=\"hiddenField\" value=\"$action\" />
			  	  <input type=\"hidden\" name=\"list\" id=\"hiddenField\" value=\"$list\" />		  	  		  	  
			  	  </td>
			  	  </tr>
			  	  </table>
			  	  </div> 
			  	  </form>"; 
			  
		$page .= $cpanel_footer;
		echo $page;
		
	} else { // The user pressed the Cancel button - We come back to the list
		$url = "lm.php?cmd=admin&action=showlists";
		header( "Location: $url" );
	}
	
}

function cpanel_editrecipient() {
	global $cmd, $list, $firstname, $lastname, $company, $email, $newemail, $result;
	global $path_to_pictures, $cpanel_header, $cpanel_footer;
	global $opt1, $opt2, $opt3, $opt4, $opt5, $opt6, $opt7, $opt8, $opt9, $opt10;
	global $opt11, $opt12, $opt13, $opt14, $opt15, $opt16, $opt17, $opt18, $opt19, $opt20;
	global $kErr_cmdprocessor_gsp, $kErr_cmdprocessor_ulf, $lang;
	global $use_mysql, $mysql_err, $mlm_err;
	
	if ( $result == "ok" && ( trim( $newemail ) == "" || !isEmailValid( $newemail ) ) ) { 
		$result = "err";
	}
	
	if ( $result == "ok" && email_exists( $list, $newemail ) && $email <> $newemail ) { 
		$result = "dup";
	}
	
	if ( $result == "err" ) {
		$title = "MLM &gt; Email Address Invalid!";
		$route = "<a href=\"lm.php\">MLM</a>
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\">
				  <span style=\"color: #F00; font-weight: normal; text-decoration: blink;\">Email Address Invalid!</span>";
	} else if ( $result == "dup" ) {
		$title = "MLM &gt; Email Address already exists!";
		$route = "<a href=\"lm.php\">MLM</a>
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\">
				  <span style=\"color: #F00; font-weight: normal; text-decoration: blink;\">Email Address already exists!</span>";
	} else {
	
		if ( $email <> "" ) {
			$title = "MLM &gt; Edit Address";
			$route = "<a href=\"lm.php\">MLM</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\">
				  <a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">$list</a>
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\">
				  <span style=\"color: #666; font-weight: normal;\">Edit Address</span>";
		} else {
			$title = "MLM &gt; New Address";
			$route = "<a href=\"lm.php\">MLM</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">$list</a>
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\">
				  <span style=\"color: #666; font-weight: normal;\">New Address</span>";
		}	
	}
	
	$page  = str_replace( "[PAGE_TITLE]", $title, $cpanel_header );
	$page  = str_replace( "[PAGE_ROUTE]", $route, $page );
	
	if ( $result == "ok" ) {

		If ( list_exists( $list ) ) {
		
			if ( $email <> "" ) {
				$result = UpdateEmailFromList( $list, $email, $newemail );
			} else {
				$email = $newemail;
				$cmd   = "subscribe";
				$reqref = GetUniqueReference();
				if ( SaveRequest( $reqref ) ) {
					if ( AddEmailToList( $reqref ) ) { $result = 1; } else { $result = -1; }
				} else {
					$result = -1;
				}
			}
			
			if ( $result == -1 ) { // Error - Server problem when reading list.

				if ( $use_mysql == 1 ) { $errorstr = " [$mysql_err]"; } else { $errorstr = " " . print_r( $mlm_err, true ); }
				
				$title   = "MLM &gt; Edit Address";
				$route   = "<a href=\"lm.php\">MLM</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">$list</a>";
				$icon    = ICON_ERROR;
				$message = $kErr_cmdprocessor_gsp[$lang] . $errorstr;
	    		$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "'\"><b>Ok</b></button>";
	
				cpanel_showdialog( $title, $route, $icon, $message, $buttons );
	
			} else { // Recipient saved successfully!
				$url = "lm.php?cmd=admin&action=showlist&list=" . urlencode( $list );
				header( "Location: $url" );
			}
			
		} else { // Error - The list '$list' was not found on this server.
				
			$title   = "MLM &gt; Edit Address";
			$route   = "<a href=\"lm.php\">MLM</a> 
				    	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    	<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				    	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    	<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">$list</a>";
			$icon    = ICON_ERROR;
			$message = str_replace( "[LIST]", "'" . $list . "'", $kErr_cmdprocessor_ulf[$lang] );
	    	$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "'\"><b>Ok</b></button>";
	
			cpanel_showdialog( $title, $route, $icon, $message, $buttons );
			
		}

	} else if ( $result == "" || $result == "err" || $result == "dup" ) { // Show the recipient edition screen with data populated
	
		$page .= "<form id=\"form1\" name=\"form1\" method=\"post\" action=\"lm.php\">
			  	  <div align=\"center\">
			  	  <table width=\"200\" border=\"0\">
			  	  <tr>
			  	  <td>";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= "<p>"; }
		$page .= "<span class=\"label\">First Name:</span><br />
			  	  <input name=\"firstname\" type=\"text\" class=\"textfieldedit\" id=\"textfield1\" value=\"$firstname\" />
			  	  <span class=\"label\">Last Name:</span><br />
			  	  <input name=\"lastname\" type=\"text\" class=\"textfieldedit\" id=\"textfield2\" value=\"$lastname\" />
			  	  <span class=\"label\">Company:</span><br />
			  	  <input name=\"company\" type=\"text\" class=\"textfieldedit\" id=\"textfield3\" value=\"$company\" />
			  	  <span class=\"label\">Email Address:</span><br />
			  	  <input name=\"newemail\" type=\"text\" class=\"textfieldedit\" id=\"textfield4\" value=\"$newemail\" />";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= "</p>"; } else { $page .= "<p>"; }
		$page .= "<div align=\"right\">
			  	  <input type=\"submit\" name=\"result\" id=\"button1\" class=\"formbutton\" value=\"Cancel\" />&nbsp;
			  	  <input type=\"submit\" name=\"result\" id=\"button2\" class=\"formbutton\" value=\"Ok\" />
			  	  </div>";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= ""; } else { $page .= "</p>"; }	  	  
		$page .= "<input type=\"hidden\" name=\"cmd\" id=\"hiddenField\" value=\"admin\" />
			  	  <input type=\"hidden\" name=\"action\" id=\"hiddenField\" value=\"editaddr\" />
			  	  <input type=\"hidden\" name=\"list\" id=\"hiddenField\" value=\"$list\" />
			  	  <input type=\"hidden\" name=\"email\" id=\"hiddenField\" value=\"$email\" />			  	  
			  	  <input type=\"hidden\" name=\"opt1\" id=\"hiddenField\" value=\"$opt1\" />
			  	  <input type=\"hidden\" name=\"opt2\" id=\"hiddenField\" value=\"$opt2\" />
			  	  <input type=\"hidden\" name=\"opt3\" id=\"hiddenField\" value=\"$opt3\" />
			  	  <input type=\"hidden\" name=\"opt4\" id=\"hiddenField\" value=\"$opt4\" />
			  	  <input type=\"hidden\" name=\"opt5\" id=\"hiddenField\" value=\"$opt5\" />
			  	  <input type=\"hidden\" name=\"opt6\" id=\"hiddenField\" value=\"$opt6\" />
			  	  <input type=\"hidden\" name=\"opt7\" id=\"hiddenField\" value=\"$opt7\" />
			  	  <input type=\"hidden\" name=\"opt8\" id=\"hiddenField\" value=\"$opt8\" />
			  	  <input type=\"hidden\" name=\"opt9\" id=\"hiddenField\" value=\"$opt9\" />
			  	  <input type=\"hidden\" name=\"opt10\" id=\"hiddenField\" value=\"$opt10\" />
			  	  <input type=\"hidden\" name=\"opt11\" id=\"hiddenField\" value=\"$opt11\" />
			  	  <input type=\"hidden\" name=\"opt12\" id=\"hiddenField\" value=\"$opt12\" />
			  	  <input type=\"hidden\" name=\"opt13\" id=\"hiddenField\" value=\"$opt13\" />
			  	  <input type=\"hidden\" name=\"opt14\" id=\"hiddenField\" value=\"$opt14\" />
			  	  <input type=\"hidden\" name=\"opt15\" id=\"hiddenField\" value=\"$opt15\" />
			  	  <input type=\"hidden\" name=\"opt16\" id=\"hiddenField\" value=\"$opt16\" />
			  	  <input type=\"hidden\" name=\"opt17\" id=\"hiddenField\" value=\"$opt17\" />
			  	  <input type=\"hidden\" name=\"opt18\" id=\"hiddenField\" value=\"$opt18\" />
			  	  <input type=\"hidden\" name=\"opt19\" id=\"hiddenField\" value=\"$opt19\" />
			  	  <input type=\"hidden\" name=\"opt20\" id=\"hiddenField\" value=\"$opt20\" />			  	  
			  	  </td>
			  	  </tr>
			  	  </table>
			  	  </div> 
			  	  </form>"; 
			  
		$page .= $cpanel_footer;
		echo $page;
		
	} else { // The user pressed the Cancel button - We come back to the list
		$url = "lm.php?cmd=admin&action=showlist&list=" . urlencode( $list );
		header( "Location: $url" );
	}
	
}

function cpanel_findrecipient() {
	global $cmd, $list, $firstname, $lastname, $company, $email, $result;
	global $path_to_pictures, $cpanel_header, $cpanel_footer;
	global $opt1, $opt2, $opt3, $opt4, $opt5, $opt6, $opt7, $opt8, $opt9, $opt10;
	global $opt11, $opt12, $opt13, $opt14, $opt15, $opt16, $opt17, $opt18, $opt19, $opt20;
	global $kErr_cmdprocessor_gsp, $kErr_cmdprocessor_ulf, $lang;
	global $use_mysql, $mysql_err, $mlm_err;
	
	if ( $result == "find" && trim( $firstname ) == "" && trim( $lastname ) == "" && trim( $company ) == "" && trim( $email ) == "" ) { 
		$result = "err";
	}

	$title = "MLM &gt; Find Address";
	$route = "<a href=\"lm.php\">MLM</a> 
		  	  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
		  	  <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
		  	  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
		  	  <span style=\"color: #666; font-weight: normal;\">Find Address</span>";

	$page  = str_replace( "[PAGE_TITLE]", $title, $cpanel_header );
	$page  = str_replace( "[PAGE_ROUTE]", $route, $page );
	
	if ( $result == "find" ) {
		$result = FindRecipient();
		if ( $result == -1 ) {
		
			$title   = "MLM &gt; Find Address";
			$route   = "<a href=\"lm.php\">MLM</a> 
						<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
						<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
						<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
						<span style=\"color: #F00; font-weight: normal; text-decoration: blink;\">Server Error</span>";
			$icon    = ICON_ERROR;
			$message = $kErr_cmdprocessor_gsp[$lang] . $errorstr;
			$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlists'\"><b>Ok</b></button>";

			cpanel_showdialog( $title, $route, $icon, $message, $buttons );

		} else if ( trim( $result ) == "" ) {
		
			$title   = "MLM &gt; Find Address";
			$route   = "<a href=\"lm.php\">MLM</a> 
						<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
						<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
						<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
						<span style=\"color: #666; font-weight: normal;\">Find Address</span>";
			$icon    = ICON_NOTE;
			$message = "No records match the search criteria.";
			$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=findaddr'\"><b>Ok</b></button>";

			cpanel_showdialog( $title, $route, $icon, $message, $buttons );
		
		} else {
			$page .= "<div align=\"center\">
					  <table width=\"CPANEL_WIDTH\" border=\"0\">
					  <tr>
					  <td><div align=\"center\">
					  <table width=\"100%\" border=\"0\"  cellpadding=\"3\" cellspacing=\"0\">";
			  
			//$page .= "<tr><td></td></tr>";
			//$page .= "<tr class=\"stdtext\">";
			//$page .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=editaddr&list=" . urlencode( $listname ) . "\"><img src=\"$path_to_pictures/icon_add.png\" border=\"0\"></a></td>";
			////$page .= "<td><img src=\"$path_to_pictures/icon_recipient.gif\" border=\"0\"></td>";
			//$page .= "<td colspan=\"5\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=editaddr&list=" . urlencode( $listname ) . "\">Add Recipient</a></td>";
			////$page .= "<td><a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $name ) . "\">Add</a></td>";
			//$page .= "</tr>\n";
			$page .= "<tr><td></td></tr>";
			$recipients = explode( "\n", $result );
			usort( $recipients, "SortByName" );
			foreach ( $recipients as $recipient ) {
				list( $firstname, $lastname, $company, $email, $list ) = explode( "\t", $recipient );
					if ( trim( $email <> "" ) ) {
						$fullname = trim( trim( $firstname ) . " " . trim( $lastname ) );
						//$data = trim( trim( $firstname ) . " " . trim( $lastname ) );
						if ( trim( $company ) <> "" ) {
							if ( $fullname <> "" ) { $fullname .= ", "; }
							$fullname .= trim( $company );
						}
						if ( trim( $fullname ) == "" ) { $fullname = "..."; }
						$data = trim( $email );
						
						if ( $mycount % 2 == 0 ) { $style = "d0"; } else { $style = "d1"; }
						$mycount++;
						//$style = "d2";
										
						$page .= "<tr class=\"$style\">";
						$page .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=removeaddr&list=" . urlencode( $list ) . "&email=" . urlencode( $email ) . "&conf=no\"><img src=\"$path_to_pictures/icon_delete.png\" border=\"0\"></a></td>";
						$page .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=editaddr&list=" . urlencode( $list ) . "&firstname=" . urlencode( $firstname ) . "&lastname=" . urlencode( $lastname ) . "&company=" . urlencode( $company ) . "&email=" . urlencode( $email ) . "\"><img src=\"$path_to_pictures/icon_edit.png\" border=\"0\"></a></td>";
						//$page .= "<td><img src=\"$path_to_pictures/icon_recipient.gif\" border=\"0\"></td>";
						if ( CPANEL_BROWSER == "iPhone" ) {
							$page .= "<td class=\"stdtext\" align=\"left\">&nbsp;<b>" . CropText( $fullname, 22 ) . "</b>
							          <br />&nbsp;<a href=\"lm.php?cmd=admin&action=sendemail&list=" . urlencode( $list ) . "&firstname=" . urlencode( $firstname ) . "&lastname=" . urlencode( $lastname ) . "&company=" . urlencode( $company ) . "&email=" . urlencode( $email ) . "\">" . CropText( $data, 22 ) . "</a>
							          <br />&nbsp;<img src=\"$path_to_pictures/icon_lists.gif\" border=\"0\">&nbsp;<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">" . CropText( $list, 22 ) . "</a>
							          </td>";
						} else {
							$page .= "<td class=\"stdtext\" align=\"left\">&nbsp;<b>" . CropText( $fullname, 40 ) . "</b><br />&nbsp;<img src=\"$path_to_pictures/icon_lists.gif\" border=\"0\">&nbsp;<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">" . CropText( $list, 22 ) . "</a></td>";
							$page .= "<td class=\"stdtext\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=sendemail&list=" . urlencode( $list ) . "&firstname=" . urlencode( $firstname ) . "&lastname=" . urlencode( $lastname ) . "&company=" . urlencode( $company ) . "&email=" . urlencode( $email ) . "\">" . CropText( $data, 40 ) . "</a></td>";
						}
						$page .= "<td width=\"14\"><a href=\"lm.php?cmd=admin&action=editaddr&list=" . urlencode( $list ) . "&firstname=" . urlencode( $firstname ) . "&lastname=" . urlencode( $lastname ) . "&company=" . urlencode( $company ) . "&email=" . urlencode( $email ) . "\"><img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"></a></td>";
						$page .= "</tr>\n";
					}
				}
				
			$page .= "</table>
					  <hr />
					  <button class=\"largebutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlists'\"><b>Return to Lists</b></button>
					  <br />
					  <button class=\"largebutton\" onClick=\"window.location='lm.php'\"><b>Main Menu</b></button>
					  <br />
					  <br />
					  </div></td>
					  </tr>
					  </table>
					  </div>";
					  
			$page .= $cpanel_footer;
			echo $page;	
		}

	} else if ( $result == "" || $result == "err" ) { // Show the recipient edition screen
	
		$page .= "<form id=\"form1\" name=\"form1\" method=\"post\" action=\"lm.php\">
			  	  <div align=\"center\">
			  	  <table width=\"200\" border=\"0\">
			  	  <tr>
			  	  <td>";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= "<p>"; }
		$page .= "<span class=\"label\">First Name:</span><br />
			  	  <input name=\"firstname\" type=\"text\" class=\"textfieldedit\" id=\"textfield1\" value=\"$firstname\" />
			  	  <span class=\"label\">Last Name:</span><br />
			  	  <input name=\"lastname\" type=\"text\" class=\"textfieldedit\" id=\"textfield2\" value=\"$lastname\" />
			  	  <span class=\"label\">Company:</span><br />
			  	  <input name=\"company\" type=\"text\" class=\"textfieldedit\" id=\"textfield3\" value=\"$company\" />
			  	  <span class=\"label\">Email Address:</span><br />
			  	  <input name=\"email\" type=\"text\" class=\"textfieldedit\" id=\"textfield4\" value=\"$email\" />";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= "</p>"; } else { $page .= "<p>"; }
		$page .= "<div align=\"right\">
			  	  <input type=\"submit\" name=\"result\" id=\"button1\" class=\"formbutton\" value=\"Cancel\" />&nbsp;
			  	  <input type=\"submit\" name=\"result\" id=\"button2\" class=\"formbutton\" value=\"Find\" />
			  	  </div>";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= ""; } else { $page .= "</p>"; }	  	  
		$page .= "<input type=\"hidden\" name=\"cmd\" id=\"hiddenField\" value=\"admin\" />
			  	  <input type=\"hidden\" name=\"action\" id=\"hiddenField\" value=\"findaddr\" />
			  	  <input type=\"hidden\" name=\"list\" id=\"hiddenField\" value=\"$list\" />		  	  
			  	  <input type=\"hidden\" name=\"opt1\" id=\"hiddenField\" value=\"$opt1\" />
			  	  <input type=\"hidden\" name=\"opt2\" id=\"hiddenField\" value=\"$opt2\" />
			  	  <input type=\"hidden\" name=\"opt3\" id=\"hiddenField\" value=\"$opt3\" />
			  	  <input type=\"hidden\" name=\"opt4\" id=\"hiddenField\" value=\"$opt4\" />
			  	  <input type=\"hidden\" name=\"opt5\" id=\"hiddenField\" value=\"$opt5\" />
			  	  <input type=\"hidden\" name=\"opt6\" id=\"hiddenField\" value=\"$opt6\" />
			  	  <input type=\"hidden\" name=\"opt7\" id=\"hiddenField\" value=\"$opt7\" />
			  	  <input type=\"hidden\" name=\"opt8\" id=\"hiddenField\" value=\"$opt8\" />
			  	  <input type=\"hidden\" name=\"opt9\" id=\"hiddenField\" value=\"$opt9\" />
			  	  <input type=\"hidden\" name=\"opt10\" id=\"hiddenField\" value=\"$opt10\" />
			  	  <input type=\"hidden\" name=\"opt11\" id=\"hiddenField\" value=\"$opt11\" />
			  	  <input type=\"hidden\" name=\"opt12\" id=\"hiddenField\" value=\"$opt12\" />
			  	  <input type=\"hidden\" name=\"opt13\" id=\"hiddenField\" value=\"$opt13\" />
			  	  <input type=\"hidden\" name=\"opt14\" id=\"hiddenField\" value=\"$opt14\" />
			  	  <input type=\"hidden\" name=\"opt15\" id=\"hiddenField\" value=\"$opt15\" />
			  	  <input type=\"hidden\" name=\"opt16\" id=\"hiddenField\" value=\"$opt16\" />
			  	  <input type=\"hidden\" name=\"opt17\" id=\"hiddenField\" value=\"$opt17\" />
			  	  <input type=\"hidden\" name=\"opt18\" id=\"hiddenField\" value=\"$opt18\" />
			  	  <input type=\"hidden\" name=\"opt19\" id=\"hiddenField\" value=\"$opt19\" />
			  	  <input type=\"hidden\" name=\"opt20\" id=\"hiddenField\" value=\"$opt20\" />			  	  
			  	  </td>
			  	  </tr>
			  	  </table>
			  	  </div> 
			  	  </form>"; 
			  
		$page .= $cpanel_footer;
		echo $page;
		
	} else { // The user pressed the Cancel button - We come back to the lists
		$url = "lm.php?cmd=admin&action=showlists";
		header( "Location: $url" );
	}
}

function cpanel_sendemail_single() {
	global $cmd, $list, $firstname, $lastname, $company, $email, $result;
	global $path_to_pictures, $cpanel_header, $cpanel_footer;
	global $admin_name_full, $admin_address, $emailencoding;
	global $subject, $message;
	
	$title = "MLM &gt; Send Message to $email";
	if ( CPANEL_BROWSER <> "iPhone" ) {
		$route = "<a href=\"lm.php\">MLM</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">$list</a>
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\">
				  <a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">$email</a>";
	} else {
		$route = "<a href=\"lm.php\">MLM</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
				  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				  <a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "\">" . CropText( $email, 10 ) . "</a>";
	}

	$page  = str_replace( "[PAGE_TITLE]", $title, $cpanel_header );
	$page  = str_replace( "[PAGE_ROUTE]", $route, $page );
		
	if ( $result == "send" ) {
		
		$headers = "From: \"$admin_name_full\" <$admin_address>";
		SendMessage( $email, $subject, $message, $headers, $emailencoding );
		$url = "lm.php?cmd=admin&action=showlist&list=" . urlencode( $list );
		header( "Location: $url" );
	
	} else if ( $result == "" ) {
	
		$page .= "<form id=\"form1\" name=\"form1\" method=\"post\" action=\"lm.php\">
			  	  <div align=\"center\">
			  	  <table width=\"200\" border=\"0\">
			  	  <tr>
			  	  <td>";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= "<p>"; }
		$page .= "<span class=\"label\">Subject:</span><br />
			  	  <input name=\"subject\" type=\"text\" class=\"textfieldedit\" id=\"textfield1\" value=\"$subject\" /><br />
			  	  <span class=\"label\">Message:</span><br />";			  	  
		if ( CPANEL_BROWSER <> "iPhone" ) {
			$page .= "<textarea name=\"message\" id=\"textarea\" cols=\"50\" rows=\"25\" class=\"textarea\">$message</textarea>";
			$page .= "</p>";
		} else { 
			$page .= "<textarea name=\"message\" id=\"textarea\" cols=\"31\" rows=\"9\" class=\"textarea\">$message</textarea>";
			$page .= "<p>";
		}
		$page .= "<div align=\"right\">
			  	  <input type=\"submit\" name=\"result\" id=\"button1\" class=\"formbutton\" value=\"Cancel\" />&nbsp;
			  	  <input type=\"submit\" name=\"result\" id=\"button2\" class=\"formbutton\" value=\"Send\" />
			  	  </div>";
		if ( CPANEL_BROWSER <> "iPhone" ) { $page .= ""; } else { $page .= "</p>"; }	  	  
		$page .= "<input type=\"hidden\" name=\"cmd\" id=\"hiddenField\" value=\"admin\" />
			  	  <input type=\"hidden\" name=\"action\" id=\"hiddenField\" value=\"sendemail\" />
			  	  <input type=\"hidden\" name=\"firstname\" id=\"hiddenField\" value=\"$firstname\" />
			  	  <input type=\"hidden\" name=\"lastname\" id=\"hiddenField\" value=\"$lastname\" />
			  	  <input type=\"hidden\" name=\"email\" id=\"hiddenField\" value=\"$email\" />
			  	  <input type=\"hidden\" name=\"list\" id=\"hiddenField\" value=\"$list\" />
			  	  </td>
			  	  </tr>
			  	  </table>
			  	  </div> 
			  	  </form>"; 
			  
		$page .= $cpanel_footer;
		echo $page;
		
	} else { // The user pressed the Cancel button - We come back to the list
		$url = "lm.php?cmd=admin&action=showlist&list=" . urlencode( $list );
		header( "Location: $url" );
	}
	
}

function cpanel_Upload() {
	global $path_to_pictures, $cpanel_header, $cpanel_footer;
	global $pwd, $added, $dup, $bad, $thebadones, $list;
	global $result, $errorstr;
	
	$title = "MLM &gt; Upload List";
	$route = "<a href=\"lm.php\">MLM</a> 
			  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
			  <a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
			  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
			  <a href=\"lm.php?cmd=admin&action=upload\">Upload</a>";
	
	//if ( $status ) { $message .= " Failed!"; }
	//if ( $status ) { $message = "<a href=\"lm.php\">MLM</a> <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> <span style=\"color: #F00; font-weight: normal; text-decoration: blink;\">Login Failed!</span>"; }
	$output  = str_replace( "[PAGE_TITLE]", $title, $cpanel_header );
	$output  = str_replace( "[PAGE_ROUTE]", $route, $output );
	
	if ( $result == 1 ) {
	
		$title   = "MLM &gt; Upload Successfull";
		$route   = "<a href=\"lm.php\">MLM</a> 
				 	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				 	<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a>";
		$icon    = ICON_NOTE;
		$message = "$added address(es) have been uploaded to '$list'.<br />MLM has found $dup duplicate(s) and $bad bad address(es).";
	    $buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlist&list=" . urlencode( $list ) . "'\"><b>Ok</b></button>";
	
		cpanel_showdialog( $title, $route, $icon, $message, $buttons );
	
	} else if ( $result == -1 ) {
	
		$title   = "MLM &gt; Upload Error";
		$route   = "<a href=\"lm.php\">MLM</a> 
				 	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				 	<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a>";
		$icon    = ICON_ERROR;
		$message = "An error occurred during the upload of recipients to '$list'.";
		If ( trim( $errorstr ) <> "" ) { $message .= "<br />$errorstr"; }
	    $buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlists'\"><b>Ok</b></button>";
	
		cpanel_showdialog( $title, $route, $icon, $message, $buttons );
	
	} else {
	
		$output .= "<form id=\"form1\" action=\"lm.php\" method=\"post\" enctype=\"multipart/form-data\" name=\"form1\">
					<div align=\"center\">
					<table width=\"200\" border=\"0\">";
					
		if ( CPANEL_BROWSER <> "iPhone" ) { $output .= "<br />"; }
					
		$output .= "<tr><td>
					<span class=\"label\">File to Upload:</span><br />
					<input type=\"file\" name=\"upload\" size=\"20\" />
					</td></tr>
					
					<tr><td>
					<span class=\"label\">Target list name:</span><br />
					<input name=\"list\" type=\"text\" class=\"textfieldedit\" id=\"textfield\" />
					</td></tr>
					
					<tr><td>
					<br />
					<span class=\"label\">Action:</span><br />
					<span class=\"stdtext\"> 
					<input type=\"radio\" name=\"action\" value=\"append\" checked=\"checked\" class=\"stdtext\" /> Append 
					<input type=\"radio\" name=\"action\" value=\"overwrite\" /> Overwrite 
					<input type=\"radio\" name=\"action\" value=\"unsubscribe\" /> Unsubscribe 
					<input type=\"radio\" name=\"action\" value=\"delete\" /> Delete
					</span>
					</td></tr>
					
					<tr><td>
					<span class=\"label\">Duplicates:</span> 
					<span class=\"stdtext\"> 
					<select name=\"dups\" id=\"select\">
					<option value=\"0\">Disallow</option>
					<option value=\"1\">Allow</option>
					</select>
					</span>
					</td></tr>
		
					<tr><td>
					<br />
					<div align=\"right\">
					<input type=\"reset\" name=\"button2\" id=\"button3\" class=\"formbutton\" value=\"Reset\" />&nbsp;
					<input type=\"submit\" name=\"button2\" id=\"button4\" class=\"formbutton\" value=\"Upload\" />
					</div>
					</td></tr>
					
					<tr><td>
					<input type=\"hidden\" name=\"cmd\" id=\"hiddenField\" value=\"upload\" />
					<input type=\"hidden\" name=\"pwd\" id=\"hiddenField\" value=\"$pwd\" />
					<input type=\"hidden\" name=\"src\" id=\"hiddenField\" value=\"cpanel\" />
					<input type=\"hidden\" name=\"return\" id=\"hiddenField\" value=\"text\" />	
					</td></tr>
					</table>
					</div> 
					</form>";
			$output .= $cpanel_footer;
			echo $output;
		}
}

function cpanel_showdeliveries() {
	global $path_to_pictures, $cpanel_header, $cpanel_footer;
	global $pwd, $page, $size, $rowsperpage;
	
	$size = GetDeliveryListSize();
	$mycount = 0;
	$offset  = 0;
	$txt = "";
	$nav = "";

	$output  = str_replace( "[PAGE_TITLE]", "MLM &gt; Deliveries", $cpanel_header );
	$output  = str_replace( "[PAGE_ROUTE]", "<a href=\"lm.php\">MLM</a> <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> <a href=\"lm.php?cmd=admin&action=showdeliveries\">Deliveries</a>", $output);
	
	$output .= "<div align=\"center\">
			  <table width=\"CPANEL_WIDTH\" border=\"0\">
			  <tr>
			  <td><div align=\"center\">
			  <table width=\"100%\" border=\"0\"  cellpadding=\"3\" cellspacing=\"0\">";
	
	$output .= "<tr><td></td></tr>";
	//$output .= "<tr class=\"stdtext\">";
	//$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $name ) . "\"><img src=\"$path_to_pictures/icon_add.png\" border=\"0\"></a></td>";
	//$output .= "<td colspan=\"5\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $name ) . "\">New List</a></td>";
	//$output .= "</tr>\n";
	//$output .= "<tr><td></td></tr>";
	
	//$rowsperpage = 5;
	
	$count = 0;
	$start = ( $rowsperpage * ( $page - 1 ) ) + 1; // Compute $start and $rows
	$deliveries = explode( "\n", ShowDeliveries( $start, $rowsperpage ) );
	foreach ( $deliveries as $delivery ) {
		$myArray[$count] = explode( "\t", $delivery );
		$count++;
	}
	usort( $myArray, "SortByDelivery" );
	
	foreach ( $myArray as $delivery ) {
		//list( $subject, $delivery_id, $delivery_date, $listname, $recipients ) = explode( "\t", $delivery );
		$subject = $delivery[0];
		$delivery_id = $delivery[1];
		if ( trim( $delivery_id <> "" ) ) {
		
			if ( $mycount % 2 == 0 ) { $style = "d0"; } else { $style = "d1"; }
			$mycount++;
			//$style = "d2";
		
			$output .= "<tr class=\"$style\">";
			$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=removedelivery&delivery=$delivery_id&conf=no\"><img src=\"$path_to_pictures/icon_delete.png\" border=\"0\"></a></td>";
			$output .= "<td width=\"22\"><a href=\"lm.php?cmd=admin&action=showdelivery&delivery=$delivery_id\"><img src=\"$path_to_pictures/icon_edit.png\" border=\"0\"></a></td>";
			
			if ( CPANEL_BROWSER == "iPhone" ) {
				$output .= "<td class=\"stdtext\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=showdelivery&delivery=$delivery_id\">$delivery_id</a> " . CropText( $subject, 22 ) . "</td>";
			} else {
				$output .= "<td class=\"stdtext\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=showdelivery&delivery=$delivery_id\">$delivery_id</a></td>";
				$output .= "<td class=\"stdtext\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=showdelivery&delivery=$delivery_id\">$subject</a></td>";
				//$output .= "<td class=\"stdtext\" align=\"left\">&nbsp;<a href=\"lm.php?cmd=admin&action=sendemail&list=" . urlencode( $listname ) . "&firstname=" . urlencode( $firstname ) . "&lastname=" . urlencode( $lastname ) . "&company=" . urlencode( $company ) . "&email=" . urlencode( $email ) . "\">$data</a></td>";
			}
			
			$output .= "<td width=\"14\"><a href=\"lm.php?cmd=admin&action=showdelivery&delivery=$delivery_id\"><img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"></a></td>";
			$output .= "</tr>\n";
		}
	}
		
	$output .= "</table>\n";

	$pages = floor( $size / $rowsperpage );
	If ( $size % $rowsperpage <> 0 ) { $pages++; }
	if ( $pages <= 1 ) {
		$nav = "";
	} else {
		if ( CPANEL_BROWSER == "iPhone" ) { $max = 24; } else { $max = 40; }
		
		$tmp_s = "";
		$tmp_x = $page;
		while ( strlen( $tmp_s ) < $max ) {
			if ( $tmp_s != "" ) { $tmp_s .= " "; }
			$tmp_s .= "$tmp_x";
			$tmp_x++;
			$offset++;
		}

		$j = $page - Floor( $offset / 2 );
		if ( $j <= 0 ) { $j = 1; }
		
		while ( strlen( $txt ) < $max && $j <= $pages ) {
			if ( $nav != "" ) {
				$nav .= " ";
				$txt .= " ";
			}
			if ( $j == $page ) {
				$nav .= "$j";
			} else {
				$nav .= "<a href=\"lm.php?cmd=admin&action=showdeliveries&page=$j&size=$size\">$j</a>";
			}
			$txt .= "$j";
			$j++;
		}
	}
	
	$prev = intval( $page ) - 1;
	$next = intval( $page ) + 1;
	
	if ( $prev > 0 || ( intval( $page ) * intval( $rowsperpage ) ) < intval( $size )  ) { 
	
		$output .= "<hr />
					<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">
					<tr>
					<td align=\"center\">					
					<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">
					<tr>";
											
		if ( $prev > 0 ) { 
			$output .= "<td align=\"center\"><a href=\"lm.php?cmd=admin&action=showdeliveries&page=1&size=$size\"><img src=\"$path_to_pictures/icon_first.png\" border=\"0\"></a></td>
						<td align=\"center\"><a href=\"lm.php?cmd=admin&action=showdeliveries&page=$prev&size=$size\"><img src=\"$path_to_pictures/icon_previous.png\" border=\"0\"></a></td>\n";
		} else {
			$output .= "<td align=\"center\"><img src=\"$path_to_pictures/icon_first_disabled.png\" border=\"0\"></td>
						<td align=\"center\"><img src=\"$path_to_pictures/icon_previous_disabled.png\" border=\"0\"></td>\n";
		}
		
		If ( $nav <> "" ) {
			$output .= "<td class=\"stdtext\" align=\"center\">&nbsp;$nav&nbsp;</td>\n";
		} else {
			$output .= "<td class=\"stdtext\" align=\"center\">&nbsp;</td>\n";
		}
		
		if ( ( intval( $page ) * intval( $rowsperpage ) < intval( $size ) ) ) { 
			$output .= "<td align=\"center\"><a href=\"lm.php?cmd=admin&action=showdeliveries&page=$next&size=$size\"><img src=\"$path_to_pictures/icon_next.png\" border=\"0\"></a></td>
						<td align=\"center\"><a href=\"lm.php?cmd=admin&action=showdeliveries&page=$pages&size=$size\"><img src=\"$path_to_pictures/icon_last.png\" border=\"0\"></a></td>\n";
		} else {
			$output .= "<td align=\"center\"><img src=\"$path_to_pictures/icon_next_disabled.png\" border=\"0\"></td>
						<td align=\"center\"><img src=\"$path_to_pictures/icon_last_disabled.png\" border=\"0\"></td>\n";
		}
		
		$output .= "</td></tr>
					</table>\n					
					</td></tr>
					</table>\n";
	}
	
	$output .= "<hr />
			    <button class=\"largebutton\" onClick=\"window.location='lm.php'\"><b>Main Menu</b></button>
			    <br />
			    <br />
			    </div></td>
			    </tr>
			    </table>
			    </div>";
			  
	$output .= $cpanel_footer;
	echo $output;
}

function cpanel_showdelivery( $delivery ) {
	global $path_to_pictures, $cpanel_header, $cpanel_footer;

	$deliverystr = number_format( $delivery, 0, ".", "," );

	$title = "MLM &gt; Delivery #$deliverystr";
	$route = "<a href=\"lm.php\">MLM</a> 
			  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
			  <a href=\"lm.php?cmd=admin&action=showdeliveries\">Deliveries</a> 
			  <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
			  <a href=\"lm.php?cmd=admin&action=showdelivery&delivery=$delivery\">$deliverystr</a>";
	
	$output  = str_replace( "[PAGE_TITLE]", $title, $cpanel_header );
	$output  = str_replace( "[PAGE_ROUTE]", $route, $output );

	$output .= "<div align=\"center\">
			  <table width=\"CPANEL_WIDTH\" border=\"0\">
			  <tr>
			  <td><div align=\"center\">
			  <table border=\"0\"  cellpadding=\"3\" cellspacing=\"0\">";
	
	$output .= "<tr><td></td></tr>";

	$traffic = explode( "\n", GetClicks( $delivery ) );
	
	$count_open = 0;
	$count_recipients = 0;
	$count_clicks = 0;
	$count_unsubscribes = 0;
	$count_bounces = 0;
	
	foreach ( $traffic as $myentry ) {
		if ( $myentry <> "" ) {
			$line = explode( "\t", $myentry );
			if ( $line[4] == "open" ) { $count_open++; }
			if ( $line[4] == "unsubscribe" ) { $count_unsubscribes++; }
			if ( $line[4] == "bounce" ) { $count_bounces++; }
			if ( $line[3] == "" ) { $count_clicks++; }
			if ( $count_recipients == "" ) { $count_recipients = $line[10]; }
		}
	}
	
	if ( $count_recipients <> 0 ) {
		$rate_open    = $count_open / $count_recipients * 100;
		$rate_clicks  = $count_clicks / $count_recipients * 100;
		$rate_unsubs  = $count_unsubscribes / $count_recipients * 100;
		$rate_bounces = $count_bounces / $count_recipients * 100;
	} else {
		$rate_open    = 0;
		$rate_clicks  = 0;
		$rate_unsubs  = 0;
		$rate_bounces = 0;
	}
	
	$mycount = 0;
	if ( $mycount % 2 == 0 ) { $style = "d0"; } else { $style = "d1"; }
	$mycount++;
	//$style = "d2";
			
	$output .= "<tr class=\"$style\">\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;<strong>Recipients:</strong></td>\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;" . number_format( $count_recipients, 0, ".", "," ) . "</td>\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;</td>\n";
	$output .= "</tr>\n";

	$output .= "<tr class=\"$style\">\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;<strong>Opening:</strong></td>\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;" . number_format( $count_open, 0, ".", "," ) . "</td>\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;" . number_format( $rate_open, 1, ".", "," ) . "%</td>\n";
	$output .= "</tr>\n";
	
	$output .= "<tr class=\"$style\">\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;<strong>Clicks:</strong></td>\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;" . number_format( $count_clicks, 0, ".", "," ) . "</td>\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;" . number_format( $rate_clicks, 1, ".", "," ) . "%</td>\n";
	$output .= "</tr>\n";
	
	$output .= "<tr class=\"$style\">\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;<strong>Unsubscribes:</strong></td>\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;" . number_format( $count_unsubscribes, 0, ".", "," ) . "</td>\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;" . number_format( $rate_unsubs, 1, ".", "," ) . "%</td>\n";
	$output .= "</tr>\n";
	
	$output .= "<tr class=\"$style\">\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;<strong>Bounces:</strong></td>\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;" . number_format( $count_bounces, 0, ".", "," ) . "</td>\n";
	$output .= "<td class=\"stdtext\" align=\"right\">&nbsp;" . number_format( $rate_bounces, 1, ".", "," ) . "%</td>\n";
	$output .= "</tr>\n";
	
	$output .= "</table>\n";
	
	$output .= "<hr />
			    <button class=\"largebutton\" onClick=\"window.location='lm.php?cmd=admin&action=showdelivery&delivery=" . addslashes( $delivery ) . "'\"><b>Refresh</b></button>
			    <br />
			    <button class=\"largebutton\" onClick=\"window.location='lm.php?cmd=admin&action=showdeliveries'\"><b>Deliveries</b></button>
			    <br />
			    <button class=\"largebutton\" onClick=\"window.location='lm.php'\"><b>Main Menu</b></button>
			    <br />
			    <br />
			    </div></td>
			    </tr>
			    </table>
			    </div>";
			  
	$output .= $cpanel_footer;
	echo $output;
	
}

function cpanel_deletedelivery( $delivery, $confirmed ) {
	global $path_to_pictures, $kErr_cmdprocessor_ulf, $lang;
	global $use_mysql, $mysql_err, $mlm_err ;
	
	if ( $confirmed == 'no' ) {
	
		$title   = "MLM &gt; Deliveries &gt; Remove $delivery";
		$route   = "<a href=\"lm.php\">MLM</a> 
				    <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    <a href=\"lm.php?cmd=admin&action=showdeliveries\">Deliveries</a> 
				    <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    <a href=\"lm.php?cmd=admin&action=showdelivery&delivery=$delivery\">$delivery</a>";
		$icon    = ICON_ALERT;
		$message = "Are you sure you want to delete the delivery $delivery ?";
	    $buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showdeliveries'\"><b>Cancel</b></button> 
				    <button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=removedelivery&delivery=" . addslashes( $delivery ) . "&conf=yes'\"><b>Ok</b></button>";
	
		cpanel_showdialog( $title, $route, $icon, $message, $buttons );
				  
	} else {
			
// 		If ( delivery_exists( $delivery ) ) {
 
 			$result = RemoveDelivery( $delivery );
 			
 			if ( !$result ) { // Error - Impossible to remove the deliverie(s).
 			
 				if ( $use_mysql == 1 ) { $errorstr = " [$mysql_err]"; } else { $errorstr = " " . print_r( $mlm_err, true ); }

				$title   = "MLM &gt; Deliveries &gt; Remove $delivery";
				$route   = "<a href=\"lm.php\">MLM</a> 
				   		    <img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showdeliveries\">Deliveries</a> 
				    		<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
				    		<a href=\"lm.php?cmd=admin&action=showdelivery&delivery=$delivery\">$delivery</a>";
 				$icon    = ICON_ERROR;
 				$message = "Error - Impossible to remove the specified deliverie(s)." . $errorstr;
 	    		$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showdeliveries'\"><b>Ok</b></button>";
 	
 				cpanel_showdialog( $title, $route, $icon, $message, $buttons );
 	
 			} else { // List removed successfully
 				$url = "lm.php?cmd=admin&action=showdeliveries";
 				header( "Location: $url" );
 			}
// 
// 		} else { // Error - The list '$listname' was not found on this server.
// 		
// 			$title   = "MLM &gt; Lists &gt; Delete $listname";
// 			$route   = "<a href=\"lm.php\">MLM</a> 
// 				    	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
// 				    	<a href=\"lm.php?cmd=admin&action=showlists\">Lists</a> 
// 				    	<img src=\"$path_to_pictures/icon_select.gif\" border=\"0\"> 
// 				    	<a href=\"lm.php?cmd=admin&action=showlist&list=" . urlencode( $listname ) . "\">$listname</a>";
// 			$icon    = ICON_ERROR;
// 			$message = str_replace( "[LIST]", "'" . $listname . "'", $kErr_cmdprocessor_ulf[$lang] );
// 	    	$buttons = "<button class=\"formbutton\" onClick=\"window.location='lm.php?cmd=admin&action=showlists'\"><b>Ok</b></button>";
// 	
// 			cpanel_showdialog( $title, $route, $icon, $message, $buttons );
// 			
// 		}
	
	}

}


function cpanel_showdialog( $title, $route, $icon, $message, $buttons ) {
	global $path_to_pictures, $cpanel_header, $cpanel_footer;
	
	$template  = "<div align=\"center\">
				  <table width=\"CPANEL_WIDTH\" border=\"0\">
				  <tr class=\"stdtext\">
				  <td><img src=\"$path_to_pictures/[ICON]\" border=\"0\"></td>
				  <td><div align=\"left\">[MESSAGE]</div></td>
				  </tr>
				  <tr>
				  <td colspan=\"2\">
				  <div align=\"right\">
				  <hr />
				  [BUTTONS]
				  </div></td>
				  </tr>
				  </table>
				  </div>";
				  
	$page  = str_replace( "[PAGE_TITLE]", $title, $cpanel_header );
	$page  = str_replace( "[PAGE_ROUTE]", $route, $page );
	
	switch ($icon) {
		case ICON_NOTE:
			$icon = "icon_note.png";
			break;
		case ICON_ALERT:
			$icon = "icon_alert.png";
			break;
		case ICON_ERROR:
			$icon = "icon_error.png";
			break;
	}
	
	$temp  = str_replace( "[ICON]", $icon, $template );
	$temp  = str_replace( "[MESSAGE]", $message, $temp );
	$temp  = str_replace( "[BUTTONS]", $buttons, $temp );

	$page .= $temp;
	$page .= $cpanel_footer;
	echo $page;

}

function SortByName( $a, $b )
{
    return strcasecmp( $a[0], $b[0] );
}

function SortByDelivery( $a, $b )
{
    if ( intval( $a[1] ) > intval( $b[1] ) ) {
    	return -1;
    } else if ( intval( $a[1] ) < intval( $b[1] ) ) {
    	return 1;
    } else {
    	return 0;
    }
}

function CropText( $text, $count ) {
	if ( strlen( $text ) > $count) {
		return substr( $text, 0, $count - 1 ) . "…";
	} else {
		return $text;
	}
}

?>